=== modified file 'drizzled/sql_string.cc'
--- drizzled/sql_string.cc	2009-02-21 02:48:50 +0000
+++ drizzled/sql_string.cc	2009-03-05 07:54:39 +0000
@@ -191,55 +191,6 @@
 }
 
 
-/*
-  Copy a multi-byte character sets with adding leading zeros.
-
-  SYNOPSIS
-
-  copy_aligned()
-  str			String to copy
-  arg_length		Length of string. This should NOT be dividable with
-			cs->mbminlen.
-  offset		arg_length % cs->mb_minlength
-  cs			Character set for 'str'
-
-  NOTES
-    For real multi-byte, ascii incompatible charactser sets,
-    like UCS-2, add leading zeros if we have an incomplete character.
-    Thus,
-      SELECT _ucs2 0xAA
-    will automatically be converted into
-      SELECT _ucs2 0x00AA
-
-  RETURN
-    0  ok
-    1  error
-*/
-
-bool String::copy_aligned(const char *str,uint32_t arg_length, uint32_t offset,
-                          const CHARSET_INFO * const cs)
-{
-  /* How many bytes are in incomplete character */
-  offset= cs->mbmaxlen - offset; /* How many zeros we should prepend */
-  assert(offset && offset != cs->mbmaxlen);
-
-  uint32_t aligned_length= arg_length + offset;
-  if (alloc(aligned_length))
-    return true;
-
-  /*
-    Note, this is only safe for big-endian UCS-2.
-    If we add little-endian UCS-2 sometimes, this code
-    will be more complicated. But it's OK for now.
-  */
-  memset(Ptr, 0, offset);
-  memcpy(Ptr + offset, str, arg_length);
-  Ptr[aligned_length]=0;
-  /* str_length is always >= 0 as arg_length is != 0 */
-  str_length= aligned_length;
-  str_charset= cs;
-  return false;
-}
 
 
 bool String::set_or_copy_aligned(const char *str,uint32_t arg_length,
@@ -248,12 +199,10 @@
   /* How many bytes are in incomplete character */
   uint32_t offset= (arg_length % cs->mbminlen);
 
-  if (!offset) /* All characters are complete, just copy */
-  {
-    set(str, arg_length, cs);
-    return false;
-  }
-  return copy_aligned(str, arg_length, offset, cs);
+  assert(!offset); /* All characters are complete, just copy */
+
+  set(str, arg_length, cs);
+  return false;
 }
 
 	/* Copy with charset conversion */
@@ -271,7 +220,8 @@
   if ((from_cs == &my_charset_bin) && offset)
   {
     *errors= 0;
-    return copy_aligned(str, arg_length, offset, to_cs);
+    assert((from_cs == &my_charset_bin) && offset);
+    return false; //copy_aligned(str, arg_length, offset, to_cs);
   }
   uint32_t new_length= to_cs->mbmaxlen*arg_length;
   if (alloc(new_length))
@@ -313,23 +263,6 @@
   return copy(str, arg_length, &my_charset_utf8_general_ci, str_charset, &dummy_errors);
 }
 
-
-/* This is used by mysql.cc */
-
-bool String::fill(uint32_t max_length,char fill_char)
-{
-  if (str_length > max_length)
-    Ptr[str_length=max_length]=0;
-  else
-  {
-    if (realloc(max_length))
-      return true;
-    memset(Ptr+str_length, fill_char, max_length-str_length);
-    str_length=max_length;
-  }
-  return false;
-}
-
 bool String::append(const String &s)
 {
   if (s.length())

=== modified file 'drizzled/sql_string.h'
--- drizzled/sql_string.h	2009-02-21 00:18:15 +0000
+++ drizzled/sql_string.h	2009-03-05 07:54:39 +0000
@@ -267,8 +267,6 @@
   static bool needs_conversion(uint32_t arg_length,
   			       const CHARSET_INFO * const cs_from, const CHARSET_INFO * const cs_to,
 			       uint32_t *offset);
-  bool copy_aligned(const char *s, uint32_t arg_length, uint32_t offset,
-		    const CHARSET_INFO * const cs);
   bool set_or_copy_aligned(const char *s, uint32_t arg_length, const CHARSET_INFO * const cs);
   bool copy(const char*s,uint32_t arg_length, const CHARSET_INFO * const csfrom,
 	    const CHARSET_INFO * const csto, uint32_t *errors);
@@ -297,7 +295,6 @@
     }
     return 0;
   }
-  bool fill(uint32_t max_length,char fill);
   friend int sortcmp(const String *a,const String *b, const CHARSET_INFO * const cs);
   friend int stringcmp(const String *a,const String *b);
   friend String *copy_if_not_alloced(String *a,String *b,uint32_t arg_length);

=== modified file 'tests/r/subselect_no_mat_and_semi_join.result'
--- tests/r/subselect_no_mat_and_semi_join.result	2009-03-05 06:45:24 +0000
+++ tests/r/subselect_no_mat_and_semi_join.result	2009-03-05 07:54:39 +0000
@@ -1,7 +1,7 @@
 show variables like 'optimizer_switch';
 Variable_name	Value
 optimizer_switch	
-set optimizer_switch='no_semijoin, no_materialization';
+set optimizer_switch='no_semijoin,no_materialization';
 drop table if exists t1,t2,t3,t4,t5,t6,t7,t8,t11,t12;
 select (select 2);
 (select 2)
@@ -1177,31 +1177,31 @@
 4
 explain extended select * from t2 where t2.a in (select a from t1);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	PRIMARY	t2	index	PRIMARY	PRIMARY	4	NULL	4	100.00	Using index
-1	PRIMARY	t1	index	PRIMARY	PRIMARY	4	NULL	4	75.00	Using where; Using index; Using join buffer
+1	PRIMARY	t2	index	NULL	PRIMARY	4	NULL	4	100.00	Using where; Using index
+2	DEPENDENT SUBQUERY	t1	unique_subquery	PRIMARY	PRIMARY	4	func	1	100.00	Using index
 Warnings:
-Note	1003	select `test`.`t2`.`a` AS `a` from (`test`.`t1`) join `test`.`t2` where (`test`.`t1`.`a` = `test`.`t2`.`a`)
+Note	1003	select `test`.`t2`.`a` AS `a` from `test`.`t2` where <in_optimizer>(`test`.`t2`.`a`,<exists>(<primary_index_lookup>(<cache>(`test`.`t2`.`a`) in t1 on PRIMARY)))
 select * from t2 where t2.a in (select a from t1 where t1.b <> 30);
 a
 2
 4
 explain extended select * from t2 where t2.a in (select a from t1 where t1.b <> 30);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	PRIMARY	t2	index	PRIMARY	PRIMARY	4	NULL	4	100.00	Using index
-1	PRIMARY	t1	ALL	PRIMARY	NULL	NULL	NULL	4	75.00	Using where; Using join buffer
+1	PRIMARY	t2	index	NULL	PRIMARY	4	NULL	4	100.00	Using where; Using index
+2	DEPENDENT SUBQUERY	t1	unique_subquery	PRIMARY	PRIMARY	4	func	1	100.00	Using where
 Warnings:
-Note	1003	select `test`.`t2`.`a` AS `a` from (`test`.`t1`) join `test`.`t2` where ((`test`.`t1`.`a` = `test`.`t2`.`a`) and (`test`.`t1`.`b` <> 30))
+Note	1003	select `test`.`t2`.`a` AS `a` from `test`.`t2` where <in_optimizer>(`test`.`t2`.`a`,<exists>(<primary_index_lookup>(<cache>(`test`.`t2`.`a`) in t1 on PRIMARY where ((`test`.`t1`.`b` <> 30) and (<cache>(`test`.`t2`.`a`) = `test`.`t1`.`a`)))))
 select * from t2 where t2.a in (select t1.a from t1,t3 where t1.b=t3.a);
 a
 2
 3
 explain extended select * from t2 where t2.a in (select t1.a from t1,t3 where t1.b=t3.a);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	PRIMARY	t2	index	PRIMARY	PRIMARY	4	NULL	4	100.00	Using index
-1	PRIMARY	t1	ALL	PRIMARY	NULL	NULL	NULL	4	75.00	Using where; Using join buffer
-1	PRIMARY	t3	eq_ref	PRIMARY	PRIMARY	4	test.t1.b	1	100.00	Using index
+1	PRIMARY	t2	index	NULL	PRIMARY	4	NULL	4	100.00	Using where; Using index
+2	DEPENDENT SUBQUERY	t1	eq_ref	PRIMARY	PRIMARY	4	func	1	100.00	
+2	DEPENDENT SUBQUERY	t3	eq_ref	PRIMARY	PRIMARY	4	test.t1.b	1	100.00	Using index
 Warnings:
-Note	1003	select `test`.`t2`.`a` AS `a` from (`test`.`t1` join `test`.`t3`) join `test`.`t2` where ((`test`.`t1`.`a` = `test`.`t2`.`a`) and (`test`.`t3`.`a` = `test`.`t1`.`b`))
+Note	1003	select `test`.`t2`.`a` AS `a` from `test`.`t2` where <in_optimizer>(`test`.`t2`.`a`,<exists>(select 1 AS `Not_used` from `test`.`t1` join `test`.`t3` where ((`test`.`t3`.`a` = `test`.`t1`.`b`) and (<cache>(`test`.`t2`.`a`) = `test`.`t1`.`a`))))
 drop table t1, t2, t3;
 create table t1 (a int, b int, index a (a,b)) ENGINE=MyISAM;
 create table t2 (a int, index a (a)) ENGINE=MyISAM;
@@ -1216,31 +1216,31 @@
 4
 explain extended select * from t2 where t2.a in (select a from t1);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	PRIMARY	t2	index	a	a	5	NULL	4	100.00	Using index
-1	PRIMARY	t1	ref	a	a	5	test.t2.a	101	100.00	Using index; FirstMatch(t2)
+1	PRIMARY	t2	index	NULL	a	5	NULL	4	100.00	Using where; Using index
+2	DEPENDENT SUBQUERY	t1	index_subquery	a	a	5	func	1001	100.00	Using index
 Warnings:
-Note	1003	select `test`.`t2`.`a` AS `a` from `test`.`t2` semi join (`test`.`t1`) where (`test`.`t1`.`a` = `test`.`t2`.`a`)
+Note	1003	select `test`.`t2`.`a` AS `a` from `test`.`t2` where <in_optimizer>(`test`.`t2`.`a`,<exists>(<index_lookup>(<cache>(`test`.`t2`.`a`) in t1 on a)))
 select * from t2 where t2.a in (select a from t1 where t1.b <> 30);
 a
 2
 4
 explain extended select * from t2 where t2.a in (select a from t1 where t1.b <> 30);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	PRIMARY	t2	index	a	a	5	NULL	4	100.00	Using index
-1	PRIMARY	t1	ref	a	a	5	test.t2.a	101	100.00	Using where; Using index; FirstMatch(t2)
+1	PRIMARY	t2	index	NULL	a	5	NULL	4	100.00	Using where; Using index
+2	DEPENDENT SUBQUERY	t1	index_subquery	a	a	5	func	1001	100.00	Using index; Using where
 Warnings:
-Note	1003	select `test`.`t2`.`a` AS `a` from `test`.`t2` semi join (`test`.`t1`) where ((`test`.`t1`.`a` = `test`.`t2`.`a`) and (`test`.`t1`.`b` <> 30))
+Note	1003	select `test`.`t2`.`a` AS `a` from `test`.`t2` where <in_optimizer>(`test`.`t2`.`a`,<exists>(<index_lookup>(<cache>(`test`.`t2`.`a`) in t1 on a where ((`test`.`t1`.`b` <> 30) and (<cache>(`test`.`t2`.`a`) = `test`.`t1`.`a`)))))
 select * from t2 where t2.a in (select t1.a from t1,t3 where t1.b=t3.a);
 a
 2
 3
 explain extended select * from t2 where t2.a in (select t1.a from t1,t3 where t1.b=t3.a);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	PRIMARY	t2	index	a	a	5	NULL	4	100.00	Using index; Start temporary
-1	PRIMARY	t1	ref	a	a	5	test.t2.a	101	100.00	Using index; FirstMatch(t2)
-1	PRIMARY	t3	index	a	a	5	NULL	3	100.00	Using where; Using index; End temporary; Using join buffer
+1	PRIMARY	t2	index	NULL	a	5	NULL	4	100.00	Using where; Using index
+2	DEPENDENT SUBQUERY	t1	ref	a	a	5	func	1001	100.00	Using index
+2	DEPENDENT SUBQUERY	t3	index	a	a	5	NULL	3	100.00	Using where; Using index; Using join buffer
 Warnings:
-Note	1003	select `test`.`t2`.`a` AS `a` from `test`.`t2` semi join (`test`.`t1` join `test`.`t3`) where ((`test`.`t1`.`a` = `test`.`t2`.`a`) and (`test`.`t3`.`a` = `test`.`t1`.`b`))
+Note	1003	select `test`.`t2`.`a` AS `a` from `test`.`t2` where <in_optimizer>(`test`.`t2`.`a`,<exists>(select 1 AS `Not_used` from `test`.`t1` join `test`.`t3` where ((`test`.`t3`.`a` = `test`.`t1`.`b`) and (<cache>(`test`.`t2`.`a`) = `test`.`t1`.`a`))))
 insert into t1 values (3,31);
 select * from t2 where t2.a in (select a from t1 where t1.b <> 30);
 a
@@ -1253,10 +1253,10 @@
 4
 explain extended select * from t2 where t2.a in (select a from t1 where t1.b <> 30);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	PRIMARY	t2	index	a	a	5	NULL	4	100.00	Using index
-1	PRIMARY	t1	ref	a	a	5	test.t2.a	101	100.00	Using where; Using index; FirstMatch(t2)
+1	PRIMARY	t2	index	NULL	a	5	NULL	4	100.00	Using where; Using index
+2	DEPENDENT SUBQUERY	t1	index_subquery	a	a	5	func	1001	100.00	Using index; Using where
 Warnings:
-Note	1003	select `test`.`t2`.`a` AS `a` from `test`.`t2` semi join (`test`.`t1`) where ((`test`.`t1`.`a` = `test`.`t2`.`a`) and (`test`.`t1`.`b` <> 30))
+Note	1003	select `test`.`t2`.`a` AS `a` from `test`.`t2` where <in_optimizer>(`test`.`t2`.`a`,<exists>(<index_lookup>(<cache>(`test`.`t2`.`a`) in t1 on a where ((`test`.`t1`.`b` <> 30) and (<cache>(`test`.`t2`.`a`) = `test`.`t1`.`a`)))))
 drop table t1, t2, t3;
 create table t1 (a int, b int) ENGINE=MyISAM;
 create table t2 (a int, b int) ENGINE=MyISAM;
@@ -4297,6 +4297,7 @@
 ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your Drizzle server version for the right syntax to use near 'INTO @v )' at line 1
 DROP TABLE t1, t2;
 set optimizer_switch='';
+ERROR 42000: Variable 'optimizer_switch' can't be set to the value of ''
 set optimizer_switch=0;
 show variables like 'optimizer_switch';
 Variable_name	Value

=== modified file 'tests/t/subselect_no_mat_and_semi_join.test'
--- tests/t/subselect_no_mat_and_semi_join.test	2009-03-05 06:45:24 +0000
+++ tests/t/subselect_no_mat_and_semi_join.test	2009-03-05 07:54:39 +0000
@@ -2,10 +2,11 @@
 # Run subselect.test without semi-join optimization (test materialize)
 #
 show variables like 'optimizer_switch';
-set optimizer_switch='no_semijoin, no_materialization';
+set optimizer_switch='no_semijoin,no_materialization';
 
 --source t/subselect.test
 
+--error 1231
 set optimizer_switch='';
 set optimizer_switch=0;
 show variables like 'optimizer_switch';

